﻿/*  MiniExplorer - File System Explorer with two panels for Google Desktop
    Copyright (C) 2007 Krzysztof Olczyk

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

var fs = new ActiveXObject("Scripting.FileSystemObject");
var shell = new ActiveXObject("WScript.Shell");

var dirs = new Array();
var dirE = new Array();
var dirL = new Array();

var active = 0;

var shiftPressed = false;

function refresh()
{
	for (i = 0; i <= 1; i++)
	{
		dirL[i].RemoveAllElements();
		for (j in dirs[i].elements)
		{
			cimg = dirs[i].elements[j].type + ".png";
			dirL[i].appendElement("<listitem onkeyup=\"itmKeyUp()\" tooltip=\"" + dirs[i].elements[j].name + "\" onmousewheel=\"lbDir_onwheel(" + i + ")\" ondblclick=\"lbDir_dblclick(" + i + ")\" name=\"" + j + "\"><img src=\"" + cimg + "\" height=\"20\" width=\"20\" /><label x=\"25\" height=\"20\">" + dirs[i].elements[j].name + "</label></listitem>");
		}
		dirE[i].value = dirs[i].location != "" ? dirs[i].location : DRIVESLOC;
		dirL[i].height = dirL[i].itemHeight * dirs[i].elements.length;
	}

	options.putValue("path1", dirs[0].location);
	options.putValue("path2", dirs[1].location);
}

function view_onOpen() 
{
	options.putDefaultValue("path1", "");
	options.putDefaultValue("path2", "");
	options.putDefaultValue("last_active", "0");
	options.putDefaultValue("said_hello", "0");

	dirs[0] = new Dir(options.getValue("path1"));
	dirs[1] = new Dir(options.getValue("path2"));

	dirE[0] = txtPath1;
	dirE[1] = txtPath2;
	dirL[0] = lbDir1;
	dirL[1] = lbDir2;

	refresh();

	updateSel(options.getValue("last_active") * 1);

	if (options.getValue("said_hello") != "1")
	{
		options.putValue("said_hello", "1");
		if(confirm(WELCOMEMSG))
		{
			shell.Run(WEBURL);

		}
	}

	Updater.directory = "http://olczyk.krzysztof.googlepages.com/gexplorer.json";
	Updater.version = 2;
	checkUpdate();
}


function txtPath_KeyPressed(n)
{
	if (event.keyCode == 13)
	{
		var newdir = dirE[n].value;

		if (newdir == "" || newdir == DRIVESLOC)
		{
			dirs[n] = new Dir("");
			dirL[n].pinY = 0;		
		}
		else if (fs.FolderExists(newdir))
		{
			dirs[n] = new Dir(newdir);
			dirL[n].pinY = 0;		
		}
		else 
		{
			if (!dirs[n].run(newdir))
				alert(ECANNOTEXECUTE + " " + newdir + "!");
		}
			
		refresh();

		return false;
	}
}

function lbDir_dblclick(n)
{
	var l = dirs[n].location;
	if (dirL[n].selectedItem == null)
		return;
	dirs[n].navigate(dirL[n].selectedItem.name);
	if (l != dirs[n].location)
		dirL[n].pinY = 0;		
	refresh();
}

function updateSel(n)
{
	active = n;
	dirL[n ^ 1].selectedIndex = -1;

	dirL[n].opacity = 255;
	dirE[n].opacity = 255;
	dirL[n ^ 1].opacity = 120;
	dirE[n ^ 1].opacity = 120;
	options.putValue("last_active", active);
}

function getSelPanel()
{
	if (dirL[0].selectedIndex > -1)
		return 0;
	else if  (dirL[1].selectedIndex > -1)
		return 1;
	else 
		return -1;
}

function btnMakeDir_click()
{
	if (dirs[active].type != "folder")
	{
		alert(ECANNOTCREATEDIRHERE);
		return;
	}

	var ndn = prompt(ENTERNAME_NEWFOLDER + " " + dirs[active].location, GADGET_NAME + " - " + NEW_DIRECTORY, TEMPL_FOLDERNAME);

	if (ndn != null)
	{
		if (!dirs[active].newdir(ndn))
		{
			alert(CANNOTCREATEDIR_EXISTS.format(ndn));
		}
		refresh();
	}
}

function scrollby(n, delta)
{
	dirL[n].pinY += delta;
	if (dirL[n].pinY < 0)
		dirL[n].pinY = 0;
	else if (dirL[n].pinY > dirL[n].height - 150)
		dirL[n].pinY = dirL[n].height - 150;

}

var scroll_intv = 0;

function startscroll(n, delta)
{
	scroll_intv = setInterval("scrollby(" + n + ", " + delta + ")", 50);
}

function stopscroll()
{
	clearInterval(scroll_intv);
}

function lbDir_onwheel(n)
{
	scrollby(n, -Event.wheelDelta/10);
}	

function itmKeyUp()
{
	kc = Event.keyCode;
	//alert(kc);
	li = dirL[active].selectedIndex;
	if (kc == 38) //up
	{
		if (shiftPressed)
		{
			var si;
			for (si = dirL[active].selectedIndex; si < dirL[active].children.count && dirL[active].children.item(si).selected; si++);

			if (si - 1 <= dirL[active].selectedIndex)
				dirL[active].selectedIndex--;
			else if (si < dirL[active].children.count)
				dirL[active].children.item(si-1).selected = false;
		}
		else
			dirL[active].selectedIndex--;
	}
	else if (kc == 33) // page up
	{
		dirL[active].selectedIndex -= 5;
	}
	else if (kc == 36) // home
	{
		dirL[active].selectedIndex = 0;
	}
	else if (kc == 40) // down
	{
		if (shiftPressed)
		{
			var si;
			for (si = dirL[active].selectedIndex; si < dirL[active].children.count && dirL[active].children.item(si).selected; si++);

			if (si - 1 <= dirL[active].selectedIndex)
				dirL[active].selectedIndex++;
			else if (si < dirL[active].children.count)
				dirL[active].children.item(si).selected = true;
		}
		else
			dirL[active].selectedIndex++;
	}
	else if (kc == 34)  // page down
	{
		dirL[active].selectedIndex += 5;
	}
	else if (kc == 35) // end
	{
		dirL[active].selectedIndex = dirL[active].children.count - 1;
	}
	else if (kc == 13) // enter
	{
		lbDir_dblclick(active);
		dirL[active].selectedIndex = 0;
		return;
	}
	else if (kc == 9) // tab
	{
		updateSel(active ^ 1);
		dirL[active].selectedIndex = 0;
		return;
	}
	else if (kc >= 48 && kc <= 90) // alphanumericals
	{
		for (i = 0; i < dirL[active].children.count; i ++)
		{
			if (dirs[active].elements[dirL[active].children.item(i).name].name.toUpperCase().charCodeAt(0) == kc)
			{
				dirL[active].selectedIndex = i;
				break;
			}
		}
	}
	else
	{
		Event.returnValue = true;
		return;
	}

	if (dirL[active].selectedIndex < 0)
	{
		if (li > dirL[active].children.count / 2)
			dirL[active].selectedIndex = dirL[active].children.count - 1;
		else
			dirL[active].selectedIndex = 0;
	}

	while (dirL[active].selectedIndex * dirL[active].itemHeight < dirL[active].pinY)
		scrollby(active, -30);
	while (dirL[active].selectedIndex * dirL[active].itemHeight > dirL[active].pinY + 150)
		scrollby(active, 30);
	
	Event.returnValue = false;
	return;	
}

function view_keyDown()
{
	if (Event.keyCode == 16)
		shiftPressed = true;
}

function view_keyUp()
{
	if (Event.keyCode == 16)
		shiftPressed = false;
}

function numSelected()
{
	var si;
	for (si = dirL[active].selectedIndex; si < dirL[active].children.count && dirL[active].children.item(si).selected; si++);
	return si - dirL[active].selectedIndex;
}


function btnRename_Click()
{
	if (dirs[active].type != "folder")
	{
		alert(ECANTDOHERE);
		return;
	}
	if (numSelected() > 1)
	{
		alert(ECANCHANGEONE);
		return;
	}

	var ind = dirL[active].selectedItem.name;
	var oldnm = dirs[active].elements[ind].name;
	
	var nn = prompt(ENTERNEWNAME.format(oldnm), RENAME_TITLE, oldnm);
	
	if (nn != null)
		if (!dirs[active].rename(ind, nn))	
			alert(ERENAMING.format(dirs[active].location + oldnm, nn));

	refresh();
}

function btnRemove_click()
{
	if (dirs[active].type != "folder")
	{
		alert(ECANTDOHERE);
		return;
	}
	
	if (numSelected() > 1)
	{
		if (!confirm(SUREDELETEMANY.format(null, dirs[active].location)))
			return;
	}
	else
	{
		var ind = dirL[active].selectedItem.name;
		if (!confirm(SUREDELETE.format(dirs[active].elements[ind].name, dirs[active].location)))
			return;
	}

	for (i = dirL[active].selectedIndex; i < dirL[active].children.count && dirL[active].children.item(i).selected; i++)
		if (!dirs[active].del(dirL[active].children.item(i).name))
		{
			alert(EDELETING.format(dirs[active].location + dirs[active].elements[dirL[active].children.item(i).name].name));
			dirs[active].refresh();
			refresh();
			return;
		}

	dirs[active].refresh();
	refresh();
}

function btnCopy_Click()
{
	if (dirs[0].type != "folder" || dirs[1].type != "folder")
	{
		alert(ECANTDOHERE);
		return;
	}

	for (i = dirL[active].selectedIndex; i < dirL[active].children.count && dirL[active].children.item(i).selected; i++)
		if (!dirs[active].copy(dirL[active].children.item(i).name, dirs[active^1].location, false))
		{
			dirs[0].refresh();
			dirs[1].refresh();
			alert(ECOPY.format(dirs[active].location + dirs[active].elements[dirL[active].children.item(i).name].name, dirs[active^1].location));
			refresh();
			return;
		}

	dirs[0].refresh();
	dirs[1].refresh();
	refresh();
}

function btnMove_Click()
{
	if (dirs[0].type != "folder" || dirs[1].type != "folder")
	{
		alert(ECANTDOHERE);
		return;
	}

	for (i = dirL[active].selectedIndex; i < dirL[active].children.count && dirL[active].children.item(i).selected; i++)
		if (!dirs[active].copy(dirL[active].children.item(i).name, dirs[active^1].location, true))
		{
			dirs[0].refresh();
			dirs[1].refresh();
			alert(EMOVE.format(dirs[active].location + dirs[active].elements[dirL[active].children.item(i).name].name, dirs[active^1].location));
			refresh();
			return;
		}

	dirs[0].refresh();
	dirs[1].refresh();
	refresh();
}


function pluginHelper.onAddCustomMenuItems(menu) 
{
	menu.AddItem(MEN_REFRESH, 0, refresh);

	if (dirs[active].type == "folder")
	{
		menu.AddItem(MEN_OPENSHELL, 0, function ()
			{
				dirs[active].openInShell();
			});
		menu.AddItem('', 0x800 /* MF_SEPARATOR */, null);
		menu.AddItem(NEW_DIRECTORY, 0, btnMakeDir_click);
		menu.AddItem(COPY, 0, btnCopy_Click);
		menu.AddItem(MOVE, 0, btnMove_Click);
		menu.AddItem(RENAME_TITLE, 0, btnRename_Click);
		menu.AddItem(REMOVE, 0, btnRemove_click);		
	}
}
